<?php
/*
    Plugin Name: vSlider
    Plugin URI: http://www.Vibethemes.com/wordpress-plugins/vslider-wordpress-image-slider-plugin/
    Description: Implementing a featured image gallery into your WordPress theme has never been easier! Showcase your portfolio, animate your header or manage your banners with vSlider. vslider by  <a href="http://www.Vibethemes.com/" title="premium wordpress themes">VibeThemes</a>.
    Author: VibeThemes.com
    Version: 3.1
    Author URI: http://www.Vibethemes.com/

	vSlider is released under GPL:
	http://www.opensource.org/licenses/gpl-license.php
*/

//  If not defined, define the path to wp-conder dir
if (!defined('WP_CONTENT_URL')) {
	define('WP_CONTENT_URL', get_option('siteurl').'/wp-content');
}

// Add thickbox to upload images
if ( $_GET['page'] == 'vslider' ) {
    add_action('admin_init', 'vslider_admin_scripts');
    add_action('admin_print_styles', 'vslider_admin_styles');
}

function vslider_admin_scripts() {
    wp_enqueue_script  ('media-upload');
    wp_enqueue_script  ('thickbox');
    wp_register_script ('vslider-upload', WP_CONTENT_URL.'/plugins/vslider/js/upload.js', array('jquery','media-upload', 'thickbox'));
    wp_enqueue_script  ('vslider-upload');
    wp_register_script ( 'colorpicker-js', WP_CONTENT_URL.'/plugins/vslider/picker/colorpicker.js', array('jquery'));
    wp_enqueue_script  ('colorpicker-js' );
    wp_register_script ( 'custom-js', WP_CONTENT_URL.'/plugins/vslider/js/custom.js', array('jquery'));
    wp_enqueue_script  ('custom-js' );
}
function vslider_admin_styles() {
    wp_enqueue_style('thickbox');
    wp_register_style('colorpicker-css', WP_CONTENT_URL.'/plugins/vslider/picker/colorpicker.css');
    wp_enqueue_style( 'colorpicker-css');
}

// ADD VSLIDER JS TO THEME HEAD SECTION
add_action('wp_print_scripts', 'vslider_head_scripts');
add_action('wp_head', 'vslider_head');

function vslider_head_scripts() {
    wp_enqueue_script ('jquery');
	wp_enqueue_script('vslider', WP_CONTENT_URL.'/plugins/vslider/js/vslider.js', $deps = array('jquery'));
}
function vslider_head() { $options = get_option('vslider_options'); ?>
<!-- Start vSlider options -->
<script type="text/javascript">var $jq = jQuery.noConflict(); $jq(document).ready(function() { $jq('#vslider').coinslider({ width: <?php echo $options['width']; ?>, height: <?php echo $options['height']; ?>, spw: <?php echo $options['spw']; ?>, sph: <?php echo $options['sph']; ?>, delay: <?php echo $options['delay']; ?>, sDelay: <?php echo $options['sDelay']; ?>, opacity: <?php echo $options['opacity']; ?>, titleSpeed: <?php echo $options['titleSpeed']; ?>, effect: '<?php echo $options["effect"]; ?>', navigation: <?php echo $options['navigation']; ?>, links : <?php echo $options['links']; ?>, hoverPause: <?php echo $options['hoverPause']; ?> }); });</script>
<style type="text/css" media="screen">#vslider { width: <?php echo $options['width']; ?>px; height: <?php echo $options['height']; ?>px;overflow: hidden; position: relative; }#vslider a, #vslider a img {border: none !important; text-decoration: none !important; outline: none !important; }#vslider h4 {color: #<?php echo $options['textColor']; ?> !important;margin: 0px !important;padding: 0px !important;font-family: <?php echo $options['fontFamily']; ?> !important;font-size: <?php echo $options['titleFont']; ?>px !important;}#vslider .cs-title {width: 100%;padding: 10px;background: #<?php echo $options['bgColor']; ?>;color: #<?php echo $options['textColor']; ?>  !important;font-family: <?php echo $options['fontFamily']; ?> !important;font-size: <?php echo $options['fontSize']; ?>px !important;letter-spacing: normal !important;line-height: normal !important;}.cs-prev, .cs-next {font-weight: bold;background: #<?php echo $options['bgColor']; ?> !important;font-size: 28px !important;font-family: "Courier New", Courier, monospace;color: #<?php echo $options['textColor']; ?> !important;padding: 0px 10px !important;-moz-border-radius: 5px;-khtml-border-radius: 5px;-webkit-border-radius: 5px;}</style>
<!-- End vSlider options -->
<?php }

// ENABLE SUPPORT FOR POST THUMBNAILS
if ( function_exists('add_theme_support') ) {
	add_theme_support('post-thumbnails');
}

// Translate the "Insert into Post" button
add_filter( 'gettext', 'my_translations', 1, 3 );
function my_translations( $translation, $text, $domain ) {
	$translations = &get_translations_for_domain( $domain );
    if ( 'Insert into Post' == $text )
        $translation = $translations->translate( 'Use as slider image' );
	return $translation;
}

// Let's set the default values
function vslider_defaults() {
    $default = array(
        'slideNr' => 3,
    	'width' => 630,
    	'height' => 280,
    	'spw' => 7,
    	'sph' => 5,
    	'delay' => 3000,
    	'sDelay' => 30,
    	'opacity' => '0.7',
    	'titleSpeed' => 1500,
    	'effect' => '',
    	'navigation' => 'true',
    	'links' => 'true',
    	'hoverPause' => 'false',
    	'fontFamily' => 'Arial, Helvetica, sans-serif',
    	'titleFont' => 16,
    	'fontSize' => 12,
    	'textColor' => 'FFFFFF',
    	'bgColor' => '222222',
    	'customImg' => 'true',
    	'chars' => 200,
    	'excerpt' => 'true',
    	'slide1' => WP_CONTENT_URL.'/plugins/vslider/images/slide1.jpg',
    	'slide2' => WP_CONTENT_URL.'/plugins/vslider/images/slide2.jpg',
    	'slide3' => WP_CONTENT_URL.'/plugins/vslider/images/slide3.jpg'
    );
return $default;
}

// Runs when plugin is activated and creates new database field
register_activation_hook(__FILE__,'vslider_plugin_install');
function vslider_plugin_install() {
    add_option('vslider_options', vslider_defaults());
}

// Runs on plugin deactivation and deletes the database field
register_deactivation_hook( __FILE__, 'vslider_plugin_remove' );
function vslider_plugin_remove() {
    delete_option('vslider_options');
}

// Reset to defaults
if ($_POST['vslider-reset'] == 1) {
    update_option('vslider_options', vslider_defaults());
    $message = '<div class="updated" id="message"><p><strong>Settings Reset to Default</strong></p></div>';
}

// Updated message
if ($_GET['updated'] == 'true') {
    $message = '<div class="updated" id="message"><p><strong>Settings Saved</strong></p></div>';
}

// Hook for adding admin menus
add_action('admin_menu', 'vslider_plugin_admin_menu');
function vslider_plugin_admin_menu() {
     add_menu_page('vSlider', 'vSlider', 8, 'vslider', 'vslider_admin_page', WP_CONTENT_URL.'/plugins/vslider/images/icon.png');
     add_submenu_page('vslider','WordPress Themes', 'WordPress Themes', 'manage_options', 'vslider-themes', 'vslider_theme_page');
    add_submenu_page('vslider','Tutorials', 'Tutorials', 'manage_options', 'vslider-tutorials', 'vslider_tutorials_page');

}

// GENERATE THEME SHOWCASE PAGE
function vslider_theme_page() { ?>
	    <div class="wrap"><div id="icon-themes" class="icon32"><br /></div><h2>vSlider Themes Page</h2>
        <?php 
        $url = 'http://www.vibethemes.com/vslidersetup/vslider-themes.php'; 
        $request = new WP_Http; 
        $result = $request->request( $url ); 
        $json = $result['body']; 
        echo $json; 
        ?>
	</div>
<?php }

// GENERATE THE TUTORIAL PAGE
function vslider_tutorials_page() { ?>
	<div class="wrap"><div id="icon-users" class="icon32"><br /></div><h2>vSlider Tutorials</h2>
        <?php
         $url = 'http://www.vibethemes.com/vslidersetup/vslider-tutorials.php'; 
         $request = new WP_Http; 
         $result = $request->request( $url ); 
         $json = $result['body']; 
         echo $json;
         ?>
	</div>
<?php }

function vslider_admin_page() { global $message; ?>
<div class="wrap" style="width:820px;"><div id="icon-options-general" class="icon32"><br /></div>
<?php echo $message; ?>
<h2><?php _e("vSlider 3.1 options Page"); ?></h2>
<?php $url = 'http://www.vibethemes.com/vslidersetup/vslider-msg.php'; $request = new WP_Http; $result = $request->request( $url ); $json = $result['body']; echo $json; ?>

<form method="post" action="options.php">
<?php wp_nonce_field('update-options'); $options = get_option('vslider_options'); ?>

	<div class="metabox-holder" style="width: 350px; float:left;">
		<div class="postbox">
		<h3><?php _e("General Setings", 'vslider'); ?></h3>
			<div class="inside" style="padding: 10px;">

                <p><?php _e("Image width", 'vslider'); ?>:<input type="text" name="vslider_options[width]" value="<?php echo $options['width'] ?>" size="3" />px&nbsp;&nbsp;<?php _e("height", 'vslider'); ?>:<input type="text" name="vslider_options[height]" value="<?php echo $options['height'] ?>" size="3" />px</p>
                <p><?php _e("Squares per width", 'vslider'); ?>:<input type="text" name="vslider_options[spw]" value="<?php echo $options['spw'] ?>" size="3" />&nbsp;&nbsp;<?php _e("per height", 'vslider'); ?>:<input type="text" name="vslider_options[sph]" value="<?php echo $options['sph'] ?>" size="3" /></p>
                <p><?php _e("Delay between images", 'vslider'); ?>:<input type="text" name="vslider_options[delay]" value="<?php echo $options['delay'] ?>" size="3" />&nbsp;in ms</p>
                <p><?php _e("Delay beetwen squares", 'vslider'); ?>:<input type="text" name="vslider_options[sDelay]" value="<?php echo $options['sDelay'] ?>" size="3" />&nbsp;in ms</p>
                <p><?php _e("Opacity of title and navigation", 'vslider'); ?>:<input type="text" name="vslider_options[opacity]" value="<?php echo $options['opacity'] ?>" size="3" /></p>
                <p><?php _e("Speed of title appereance", 'vslider'); ?>:<input type="text" name="vslider_options[titleSpeed]" value="<?php echo $options['titleSpeed'] ?>" size="3" />&nbsp;in ms</p>
                <p><?php _e("Effect", 'vslider'); ?>:<select name="vslider_options[effect]"><option value="" <?php selected('', $options['effect']); ?>>all combined</option><option value="random" <?php selected('random', $options['effect']); ?>>random</option><option value="swirl" <?php selected('swirl', $options['effect']); ?>>swirl</option><option value="rain" <?php selected('rain', $options['effect']); ?>>rain</option><option value="straight" <?php selected('straight', $options['effect']); ?>>straight</option></select></p>
                <p><?php _e("Show navigation buttons", 'vslider'); ?>:<select name="vslider_options[navigation]"><option value="true" <?php selected('true', $options['navigation']); ?>>Yes</option><option value="false" <?php selected('false', $options['navigation']); ?>>No</option></select></p>
                <p><?php _e("Show images as links ", 'vslider'); ?>:<select name="vslider_options[links]"><option value="true" <?php selected('true', $options['links']); ?>>Yes</option><option value="false" <?php selected('false', $options['links']); ?>>No</option></select></p>
                <p><?php _e("Pause on mouse hover", 'vslider'); ?>:<select name="vslider_options[hoverPause]"><option value="true" <?php selected('true', $options['hoverPause']); ?>>Yes</option><option value="false" <?php selected('false', $options['hoverPause']); ?>>No</option></select></p>
                <p><?php _e("Font family", 'vslider'); ?>:<select name="vslider_options[fontFamily]"><option value="'Trebuchet MS', Helvetica, sans-serif" <?php selected("'Trebuchet MS', Helvetica, sans-serif", $options['fontFamily']); ?>>'Trebuchet MS', Helvetica, sans-serif</option><option value="Arial, Helvetica, sans-serif" <?php selected('Arial, Helvetica, sans-serif', $options['fontFamily']); ?>>Arial, Helvetica, sans-serif</option><option value="Tahoma, Geneva, sans-serif" <?php selected('Tahoma, Geneva, sans-serif', $options['fontFamily']); ?>>Tahoma, Geneva, sans-serif</option><option value="Verdana, Geneva, sans-serif" <?php selected('Verdana, Geneva, sans-serif', $options['fontFamily']); ?>>Verdana, Geneva, sans-serif</option><option value="Georgia, serif" <?php selected('Georgia, serif', $options['fontFamily']); ?>>Georgia, serif</option><option value="'Arial Black', Gadget, sans-serif" <?php selected("'Arial Black', Gadget, sans-serif", $options['fontFamily']); ?>>'Arial Black', Gadget, sans-serif</option><option value="'Bookman Old Style', serif" <?php selected("'Bookman Old Style', serif", $options['fontFamily']); ?>>'Bookman Old Style', serif</option><option value="'Comic Sans MS', cursive" <?php selected("'Comic Sans MS', cursive", $options['fontFamily']); ?>>'Comic Sans MS', cursive</option><option value="'Courier New', Courier, monospace" <?php selected("'Courier New', Courier, monospace", $options['fontFamily']); ?>>'Courier New', Courier, monospace</option><option value="Garamond, serif" <?php selected("Garamond, serif", $options['fontFamily']); ?>>Garamond, serif</option><option value="'Times New Roman', Times, serif" <?php selected("'Times New Roman', Times, serif", $options['fontFamily']); ?>>'Times New Roman', Times, serif</option><option value="Impact, Charcoal, sans-serif" <?php selected("Impact, Charcoal, sans-serif", $options['fontFamily']); ?>>Impact, Charcoal, sans-serif</option><option value="'Lucida Console', Monaco, monospace" <?php selected("'Lucida Console', Monaco, monospace", $options['fontFamily']); ?>>'Lucida Console', Monaco, monospace</option><option value="'MS Sans Serif', Geneva, sans-serif" <?php selected("'MS Sans Serif', Geneva, sans-serif", $options['fontFamily']); ?>>'MS Sans Serif', Geneva, sans-serif</option></select></p>
                <p><?php _e("Title font size", 'vslider'); ?>:<input type="text" name="vslider_options[titleFont]" value="<?php echo $options['titleFont'] ?>" size="3" />px</p>
                <p><?php _e("Text font size", 'vslider'); ?>:<input type="text" name="vslider_options[fontSize]" value="<?php echo $options['fontSize'] ?>" size="3" />px</p>
                <p><?php _e("Text color", 'vslider'); ?>:<input id="textColor" type="text" name="vslider_options[textColor]" value="<?php echo $options['textColor'] ?>" size="8" />&nbsp;HEX</p>
                <p><?php _e("Background color", 'vslider'); ?>:<input id="bgColor" type="text" name="vslider_options[bgColor]" value="<?php echo $options['bgColor'] ?>" size="8" />&nbsp;HEX</p>
                <small><?php _e("Click on the text box to pick a color", 'vslider'); ?></small>

                <p><input type="submit" class="button" value="<?php _e('Save Settings') ?>" /></p>

			</div>
		</div>
	</div>

	<div class="metabox-holder" style="width: 450px;float:right;margin-bottom:-10px;">
		<div class="postbox">
		<h3><?php _e("Images Source", 'vslider'); ?></h3>
			<div class="inside" style="padding: 10px;">

                <p><?php _e("Source", 'vslider'); ?>?&nbsp;
                <select name="vslider_options[customImg]">
                    <option value="true" <?php selected('true', $options['customImg']); ?>>Custom</option>
                    <option value="false" <?php selected('false', $options['customImg']); ?>>Category</option>
                </select>&nbsp;
				<?php _e("Category:", 'vslider'); ?>
                <?php wp_dropdown_categories(array('selected' => $options['imgCat'], 'name' => 'vslider_options[imgCat]', 'orderby' => 'Name' , 'hierarchical' => 1, 'show_option_all' => __("All Categories", 'vslider'), 'hide_empty' => '0' )); ?></p>
                <p><?php _e("Slides", 'vslider'); ?>:
                <select name="vslider_options[slideNr]">
                <?php for($s=1; $s<21; $s++){ ?>
                    <option value="<?php echo $s; ?>" <?php selected($s, $options['slideNr']); ?>><?php echo $s; ?></option>
                <?php } ?>
                </select>
                <?php _e("Display post excerpt", 'vslider'); ?>?&nbsp;
                <select name="vslider_options[excerpt]">
                    <option value="true" <?php selected('true', $options['excerpt']); ?>>Yes</option>
                    <option value="false" <?php selected('false', $options['excerpt']); ?>>No</option>
                </select>&nbsp;
                <?php _e("chars", 'vslider'); ?>:
                <input type="text" name="vslider_options[chars]" value="<?php echo $options['chars'] ?>" size="3" />
                </p>

                <p><input type="submit" class="button" value="<?php _e('Save Settings') ?>" /></p>

			</div>
		</div>
	</div>

    <?php $slides = $options['slideNr'] + 1; ?>
    <?php for($x=1; $x<$slides; $x++){ ?>
	<div class="metabox-holder" style="width: 450px;float:right;margin-bottom:-10px;">
		<div class="postbox">
		<h3><?php _e("Custom Image", 'vslider'); ?> <?php echo $x; ?><div class="click" id="<?php echo $x; ?>" style="float:right;cursor:pointer;"><?php _e("(+/-)", 'vslider'); ?></div></h3>
			<div class="inside" id="box<?php echo $x; ?>" style="padding: 10px;display:none;">

                <p><?php _e("Image URL", 'vslider'); ?>: <small style="float:right;"><?php _e("uplad", 'vslider'); ?></small><br />
                <input id="slide<?php echo $x; ?>" type="text" name="vslider_options[slide<?php echo $x; ?>]" value="<?php echo $options['slide'.$x.''] ?>" size="62" />
                <a href="media-upload.php?type=image&amp;TB_iframe=true" class="thickbox" onclick="current_image='slide<?php echo $x; ?>';"><img src='images/media-button-image.gif' alt='Add an Image' /></a><br />
                <?php _e("Image links to", 'vslider'); ?>:<br />
                <input type="text" name="vslider_options[link<?php echo $x; ?>]" value="<?php echo $options['link'.$x.''] ?>" size="62" /><br />
				<?php _e("Heading text", 'vslider'); ?>:<br />
                <input type="text" name="vslider_options[heading<?php echo $x; ?>]" value="<?php echo $options['heading'.$x.''] ?>" size="62" /><br />
				<?php _e("Description text", 'vslider'); ?>:<br />
                <textarea name="vslider_options[desc<?php echo $x; ?>]" cols=51 rows=3><?php echo $options['desc'.$x.''] ?></textarea>
                </p>
                <p><input type="submit" class="button" value="<?php _e('Save Settings') ?>" /></p>

			</div>
		</div>
	</div>
    <?php } ?>

<input type="hidden" name="action" value="update" />
<input type="hidden" name="page_options" value="vslider_options" />
</form>


<form method="post" style="clear:both;">
<input type="hidden" name="vslider-reset" value="1">
<p><input type="submit" class="button-primary" onclick="return confirm('Are you sure you want to reset to default settings?')" value="<?php _e('Reset') ?>" /></p>
</form>

</div>
<?php }

// LIMIT CONTENT FUNCTION
function vslider_limitpost ($max_char, $more_link_text = '(more...)', $stripteaser = 0, $more_file = '') {
    $content = get_the_content($more_link_text, $stripteaser, $more_file);
    $content = apply_filters('the_content', $content);
    $content = str_replace(']]>', ']]&gt;', $content);
    $content = strip_tags($content);

   if (strlen($_GET['p']) > 0) {
      echo $content;
      echo "&nbsp;<a rel='nofollow' href='";
      the_permalink();
      echo "'>".__('Read More', 'vibe')." &rarr;</a>";
   }
   else if ((strlen($content)>$max_char) && ($espacio = strpos($content, " ", $max_char ))) {
        $content = substr($content, 0, $espacio);
        $content = $content;
        echo $content;
        echo "...";
        echo "&nbsp;<a rel='nofollow' href='";
        the_permalink();
        echo "'>".$more_link_text."</a>";
   }
   else {
      echo $content;
      echo "&nbsp;<a rel='nofollow' href='";
      the_permalink();
      echo "'>".__('Read More', 'vibe')." &rarr;</a>";
   }
}

// VSLIDER
function vslider() { $options = get_option('vslider_options');

  echo '<div id="vslider">';
  if($options['customImg'] == 'false') {
      $recent = new WP_Query("cat=".$options['imgCat']."&showposts=".$options['slideNr']); while($recent->have_posts()) : $recent->the_post(); ?>
          <a href="<?php the_permalink(); ?>"><?php the_post_thumbnail ( array($options['width'], $options['height']) ); ?>
          <?php if($options['excerpt'] == 'true') { ?>
              <span><h4><?php the_title(); ?></h4><?php vslider_limitpost($options['chars'], "" ); ?></span>
          <?php } ?>
          </a>
      <?php endwhile;
  } else {
    $slides = $options['slideNr'] + 1;
    for($x=1; $x<$slides; $x++){ ?>
       <a href="<?php echo $options['link'.$x.'']; ?>">
       <img src="<?php echo $options['slide'.$x.'']; ?>" style="width:<?php echo $options['width']; ?>px;height:<?php echo $options['height']; ?>px;" alt="<?php echo $options['heading'.$x.'']; ?>" />
         <?php if($options['heading'.$x.'']) { ?>
           <span><h4><?php echo $options['heading'.$x.'']; ?></h4><?php echo $options['desc'.$x.'']; ?></span>
         <?php } ?>
       </a>
    <?php }
  }
  echo '</div>';

}

// Add vSlider short code
function vslider_short_code($atts) {
	ob_start();
	vslider();
	$output = ob_get_clean();
	return $output;
}
add_shortcode('vslider', 'vslider_short_code');

// REGISTER VSLIDER AS WIDGET
add_action('widgets_init', create_function('', "register_widget('vslider_widget');"));
class vslider_widget extends WP_Widget {

	function vslider_widget() { $options = get_option('vslider_options');
		$widget_ops = array( 'classname' => 'vslider-widget', 'description' => 'jQuery Image Slider' );
		$control_ops = array( 'width' => 200, 'height' => 250, 'id_base' => 'vslider-widget' );
		$this->WP_Widget( 'vslider-widget', 'vSlider Widget', $widget_ops, $control_ops );
	}

	function widget($args, $instance) {
		extract($args);

		echo $before_widget;

			if (!empty($instance['title']))
				echo $before_title . $instance['title'] . $after_title;

    vslider ();

	echo $after_widget;
	}

	function update($new_instance, $old_instance) {
		return $new_instance;
	}

	function form($instance) { ?>
		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e("Title"); ?>:</label>
			<input id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" value="<?php echo $instance['title']; ?>" style="width:95%;" /></p>

	<?php
	}
}

?>